<template>
  <el-main>
    <el-row>
      <el-col :span="3">
        <label>prefix</label><el-input placeholder="prefix-" v-model="prefix"></el-input>
      </el-col>
      <el-col :span="3">
        <label>suffix</label><el-input placeholder="-suffix" v-model="suffix"></el-input>
      </el-col>
      <el-col :span="3">
        <label>init</label><el-input type="number" v-model="init"></el-input>
      </el-col>
      <el-col :span="3">
        <label>step</label><el-input type="number" v-model="step"></el-input>
      </el-col>
      <el-col :span="3">
        <label>end</label><el-input type="number" v-model="end"></el-input>
      </el-col>
      <el-col :span="3">
        <label>radix</label>
        <el-select v-model="radix">
          <el-option :value="2"  label="2進数"></el-option>
          <el-option :value="8"  label="8進数"></el-option>
          <el-option :value="10" label="10進数"></el-option>
          <el-option :value="16" label="16進数"></el-option>
        </el-select>
      </el-col>
      <el-col :span="3">
        <label>upper case</label><br>
        <el-checkbox :disabled="upcase_disabled" v-model="upcase"></el-checkbox>
      </el-col>
      <el-col :span="3">
        <label>padding</label><el-input type="number" v-model="padding"></el-input>
      </el-col>
    </el-row>
    <el-row>
      <el-col :span="4" :offset="10">
        <el-button @click="generate" type="primary" round>作成！</el-button>
      </el-col>
    </el-row>
    <el-row>
      <el-col :span="24">
        <el-input type="textarea" placeholder="" :rows="10" v-model="output"></el-input>
      </el-col>
    </el-row>
  </el-main>
</template>

<script>
import _ from 'lodash'

export default {
  data() {
    return {
      prefix: "",
      suffix: "",
      init: 0,
      step: 1,
      end: 10,
      radix: 10,
      upcase: true,
      padding: 0,
      output: ""
    }
  },
  computed: {
    upcase_disabled() {
      return this.radix !== 16
    }
  },
  methods: {
    generate() {
      let retVal = ""

      for (let i = (this.init | 0); i <= this.end; i += (this.step | 0)) {
        console.log(i)
        retVal += this.prefix

        let num = i.toString(this.radix)

        if (this.radix == 16 && this.upcase) {
          num = num.toUpperCase()
        }

        if (this.padding == 0) {
          retVal += (num + "")
        } else {
          retVal += ('0'.repeat(this.padding) + num).slice(-this.padding)
        }

        retVal += this.suffix + "\n"
      }

      this.output = retVal
    }
  }
}
</script>